/* 
Function that converts input data to a string
Handles named objects and their groups. Requires FindInArray_OFPCWA.sqf
This is a wrapper function that prepares input for the Convert_NamedObj_To_String.sqf
by Faguss (ofp-faguss.com) 09.07.21

Usage:
	IS_CWA                          = Format ["%1",getworld]!="scalar bool array string 0xfcffffef"
	FindInArray_OFPCWA              = preProcessFile "FindInArray_OFPCWA.sqf"
	CONVERT_NAMEDOBJ_TO_STRING_INIT = preProcessFile "Convert_NamedObj_To_String_Init.sqf"
	CONVERT_NAMEDOBJ_TO_STRING      = preProcessFile "Convert_NamedObj_To_String.sqf"
	[<data>, <named units>] call CONVERT_NAMEDOBJ_TO_STRING_INIT

Example:
	[[soldier1,soldier2,soldier3], ["soldier1","soldier2","soldier3"]] call CONVERT_NAMEDOBJ_TO_STRING_INIT
*/

private ["_named_units", "_named_groups"];
_named_units    = [];
_named_groups   = [];

{
	_named_units set  [count _named_units , call _x]; 
	_named_groups set [count _named_groups, group (call _x)]
} forEach (_this select 1);

[(_this select 0), (_this select 1), _named_units, _named_groups] call CONVERT_NAMEDOBJ_TO_STRING