/* 
Function that converts input data to a string
Handles named objects and their groups. Requires FindInArray_OFPCWA.sqf
Has to be called through Convert_NamedObj_To_String_Init.sqf
by Faguss (ofp-faguss.com) 09.07.21

Usage:
	IS_CWA                          = Format ["%1",getworld]!="scalar bool array string 0xfcffffef"
	FindInArray_OFPCWA              = preProcessFile "FindInArray_OFPCWA.sqf"
	CONVERT_NAMEDOBJ_TO_STRING_INIT = preProcessFile "Convert_NamedObj_To_String_Init.sqf"
	CONVERT_NAMEDOBJ_TO_STRING      = preProcessFile "Convert_NamedObj_To_String.sqf"
	[<data>, <named units>] call CONVERT_NAMEDOBJ_TO_STRING_INIT

Example:
	[[soldier1,soldier2,soldier3], ["soldier1","soldier2","soldier3"]] call CONVERT_NAMEDOBJ_TO_STRING_INIT
*/

private ["_string", "_index"];

// if scalar
if ((_this select 0) in [(_this select 0)]) then {

	// if string
	if ((_this select 0) in [Format["%1",(_this select 0)]]) then {
		"{" + (_this select 0) + "}"
	} else {
		
		// if named object
		_index = [(_this select 0),(_this select 2)] call FindInArray_OFPCWA;
		if (_index >= 0) then {
			(_this select 1) select _index
		} else {
			
			// if named group
			_index = [(_this select 0),(_this select 3)] call FindInArray_OFPCWA;
			if (_index >= 0) then {	
				"group " + ((_this select 1) select _index)
			} else {
			
				// if number / boolean / side
				Format ["%1",(_this select 0)]
			}
		}
	}
} else {

	// if array
	_string = "[";
	{_string = _string + "]+[" + ([_x, (_this select 1), (_this select 2), (_this select 3)] call CONVERT_NAMEDOBJ_TO_STRING)} forEach (_this select 0);
	_string + "]"
}