/* 
Function that converts input data to a string
Handles objects and groups. Requires Fwatch 1.15
by Faguss (ofp-faguss.com) 09.07.21

Usage:
	CONVERT_OBJGRP_TO_STRING = preProcessFile "Convert_ObjGrp_To_String.sqf"
	<data> call CONVERT_OBJGRP_TO_STRING

Example:
	[group player,grpNull] call CONVERT_OBJGRP_TO_STRING
*/

private ["_string"];

// if scalar
if (_this in [_this]) then {	
	
	// if string
	if (_this in [Format["%1",_this]]) then {
		"{" + _this + "}"
	} else {

		// if boolean / side
		if (_this in [west,east,resistance,civilian,logic,enemy,true,false]) then {
			Format ["%1",_this]
		} else {
		
			// if number
			if (loadFile Format ["\:STRING ISNUMBER text:%1",_this] != "string") then {
				Format ["%1",_this]
			} else {
			
				// if not objNull / grpNull
				if (_this == _this) then {
				
					// if object
					if ("_x=={:} || _x=={#}" count (call loadFile Format ["\:STRING SPLIT text:%1",_this]) > 0) then {
						Format ["nearestObject [%1,""%2""]", getPos _this, typeOf _this]
					} else {
					
						// if group
						Format ["group nearestObject [%1,""%2""]", getPos (units _this select 0), typeOf (units _this select 0)]
					}
					
				} else {
				
					// if objNull / grpNull
					if (Format ["%1",_this] == "<NULL-group>") then {
						"grpNull"
					} else {
						"objNull"
					}
				}
				
			}
		}
		
	}
} else {	

	// if array
	_string = "[";
	{_string = _string + "]+[" + (_x call CONVERT_OBJGRP_TO_STRING)} forEach _this;
	_string + "]"
}