/* 
Function that converts input data to a string
Handles objects (but not groups)
by Faguss (ofp-faguss.com) 09.07.21

Usage:
	CONVERT_OBJ_TO_STRING = preProcessFile "Convert_Obj_To_String.sqf"
	<data> call CONVERT_OBJ_TO_STRING

Example:
	[player,objNull] call CONVERT_OBJ_TO_STRING
*/

private ["_string"];

// if scalar
if (_this in [_this]) then {

	// if string
	if (_this in [Format["%1",_this]]) then {
		"{" + _this + "}"
	} else {
	
		// if object
		if ("All" countType [_this] > 0) then {
			Format ["nearestObject [%1,""%2""]", getPos _this, typeOf _this]
		} else {
		
			// if number / boolean / side
			Format ["%1",_this]
		}

	}
} else {
	
	// if array
	_string = "[";
	{_string = _string + "]+[" + (_x call CONVERT_OBJ_TO_STRING)} forEach _this;
	_string + "]"
}